> ## Documentation Index
> Fetch the complete documentation index at: https://developers.fireblocks.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Issue a token on one or more blockchains

> Facilitates the creation of a new token on one or more blockchains.



## OpenAPI

````yaml https://docs.fireblocks.com/api/v1/swagger.yaml post /tokenization/multichain/tokens
openapi: 3.0.0
info:
  title: Fireblocks API
  description: >
    Fireblocks provides a suite of applications to manage digital asset
    operations and a complete development platform to build your business on the
    blockchain.


    - Visit our website for more information: [Fireblocks
    Website](https://fireblocks.com)

    - Visit our developer docs: [Fireblocks
    DevPortal](https://developers.fireblocks.com)
  version: 1.6.2
  contact:
    email: developers@fireblocks.com
servers:
  - url: https://api.fireblocks.io/v1
    description: Fireblocks Production Environment Base URL
  - url: https://sandbox-api.fireblocks.io/v1
    description: Fireblocks Sandbox Environment Base URL
security: []
paths:
  /tokenization/multichain/tokens:
    post:
      tags:
        - Tokenization
      summary: Issue a token on one or more blockchains
      description: Facilitates the creation of a new token on one or more blockchains.
      operationId: issueTokenMultiChain
      parameters:
        - $ref: '#/components/parameters/X-Idempotency-Key'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateMultichainTokenRequest'
      responses:
        '201':
          description: Tokens were created successfully
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/IssueTokenMultichainResponse'
        '400':
          description: Invalid input.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InvalidParamaterValueError'
        '409':
          description: Address is already taken.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AddressNotAvailableError'
      x-codeSamples:
        - lang: TypeScript
          source: >-
            const response:
            Promise<FireblocksResponse<IssueTokenMultichainResponse>> =
            fireblocks.tokenization.issueTokenMultiChain(tokenizationApiIssueTokenMultiChainRequest);
        - lang: Java
          source: >-
            CompletableFuture<ApiResponse<List<TokenLinkDto>>> response =
            fireblocks.tokenization().issueTokenMultiChain(createMultichainTokenRequest,
            idempotencyKey);
        - lang: Python
          source: >-
            response =
            fireblocks.tokenization.issue_token_multi_chain(create_multichain_token_request,
            idempotency_key);
components:
  parameters:
    X-Idempotency-Key:
      name: Idempotency-Key
      in: header
      description: >-
        A unique identifier for the request. If the request is sent multiple
        times with the same idempotency key, the server will return the same
        response as the first request. The idempotency key is valid for 24
        hours.
      required: false
      schema:
        type: string
  schemas:
    CreateMultichainTokenRequest:
      type: object
      properties:
        vaultAccountId:
          type: string
          example: '0'
          description: >-
            The id of the vault account that initiated the request to issue the
            token
        createParams:
          oneOf:
            - $ref: '#/components/schemas/EVMTokenCreateParamsDto'
        salt:
          type: string
          description: >-
            The salt to calculate the deterministic address. Must be a number
            between 0 and 2^256 -1, for it to fit in the bytes32 parameter.
          example: '123456789'
        chains:
          type: array
          items:
            type: string
          description: >-
            The base asset identifiers of the blockchains (legacyId) to
            calculate deterministic addresses
          example:
            - ETH
            - POLYGON
        displayName:
          type: string
        useGasless:
          type: boolean
          example: false
          description: >-
            Indicates whether the token should be created in a gasless manner,
            utilizing the ERC-2771 standard. When set to true, the transaction
            will be relayed by a designated relayer. The workspace must be
            configured to use Fireblocks gasless relay.
        fee:
          type: string
          description: >-
            Max fee amount for the write function transaction. interchangeable
            with the 'feeLevel' field
          example: '2000'
        feeLevel:
          enum:
            - LOW
            - MEDIUM
            - HIGH
          type: string
          description: >-
            Fee level for the write function transaction. interchangeable with
            the 'fee' field
          example: MEDIUM
      required:
        - vaultAccountId
        - createParams
        - chains
    IssueTokenMultichainResponse:
      description: Response schema for issuing tokens across multiple chains
      type: array
      items:
        $ref: '#/components/schemas/TokenLinkDto'
    InvalidParamaterValueError:
      type: object
      properties:
        message:
          type: string
          description: Bad request error message
          example: Invalid initParams.
        code:
          type: number
          description: Error code
          example: 400
      required:
        - message
        - code
    AddressNotAvailableError:
      type: object
      properties:
        message:
          type: string
          description: Conflict error message
          example: Address is already taken
        code:
          type: number
          description: Error code
          example: 409
      required:
        - message
        - code
    EVMTokenCreateParamsDto:
      type: object
      properties:
        contractId:
          type: string
          example: b70701f4-d7b1-4795-a8ee-b09cdb5b850d
          description: >-
            The id of the contract template that will be used to create the
            token
        deployFunctionParams:
          example:
            - internalType: string
              name: name
              type: string
              value: name
            - internalType: string
              name: symbol
              type: string
              value: symbol
            - components:
                - internalType: bool
                  name: _isMintable
                  type: bool
              internalType: struct MyStruct
              name: customConfigProps
              type: tuple
              value:
                - internalType: bool
                  name: _isMintable
                  type: bool
                  value: false
          description: The deploy function parameters and values of the contract template
          type: array
          items:
            $ref: '#/components/schemas/ParameterWithValue'
      required:
        - contractId
    TokenLinkDto:
      type: object
      properties:
        id:
          type: string
          description: The token link id
          example: fbfbfbfb-fbfb-fbfb-fbfb-fbfbfbfbfbfb
        status:
          enum:
            - PENDING
            - COMPLETED
          type: string
          description: The token status
          example: COMPLETED
        type:
          enum:
            - FUNGIBLE_TOKEN
            - NON_FUNGIBLE_TOKEN
            - TOKEN_UTILITY
            - TOKEN_EXTENSION
          type: string
          description: The type of token
          example: NON_FUNGIBLE_TOKEN
        refId:
          type: string
          description: The Fireblocks' reference id
          example: BQ5R_MY_TOKEN
        displayName:
          type: string
          description: >-
            The token display name. If was not provided, would be taken from the
            contract template
          example: My Simple ERC20 Token
        tokenMetadata:
          description: The token's metadata
          oneOf:
            - $ref: '#/components/schemas/AssetMetadataDto'
            - $ref: '#/components/schemas/CollectionMetadataDto'
            - $ref: '#/components/schemas/ContractMetadataDto'
      required:
        - id
        - status
    ParameterWithValue:
      type: object
      properties:
        name:
          type: string
          example: _name
          description: The name of the parameter as it appears in the ABI
        description:
          type: string
          example: The name of the token
          description: >-
            A description of the parameter, fetched from the devdoc of this
            contract
        internalType:
          type: string
          example: string
          description: The  internal type of the parameter as it appears in the ABI
        type:
          type: string
          example: string
          description: The type of the parameter as it appears in the ABI
        components:
          type: array
          items:
            $ref: '#/components/schemas/Parameter'
        value:
          example: 'true'
          description: The value of the parameter. can also be ParameterWithValue
          type: string
        functionValue:
          description: >-
            The function value of this param (if has one). If this is set, the
            `value` shouldn`t be. Used for proxies
          allOf:
            - $ref: '#/components/schemas/LeanAbiFunction'
      required:
        - name
        - type
    AssetMetadataDto:
      type: object
      properties:
        assetId:
          type: string
          description: The Fireblocks` asset id
          example: BQ5R_MY_TOKEN
        name:
          type: string
          description: The name of the token
          example: MyToken
        symbol:
          type: string
          description: The symbol of the token
          example: MYT
        networkProtocol:
          type: string
          description: The network protocol of the token
          example: ETH
        totalSupply:
          type: string
          description: The total supply of the token
          example: '1000000000000000'
        holdersCount:
          type: number
          description: The number of holders of the token
          example: '6'
        type:
          type: string
          description: The type of the token
          example: ERC20
        contractAddress:
          type: string
          description: The address of the token contract
          example: '0x1234567890abcdef1234567890abcdef12345678'
        issuerAddress:
          type: string
          description: In case of Stellar or Ripple, the address of the issuer of the token
          example: rGyXjc5d7s17vvt3NtKKascvJrnSxV21kQ
        testnet:
          type: boolean
          description: Is it deployed on testnet or to mainnet
          example: true
        blockchain:
          type: string
          description: The blockchain native asset id which the token is deployed on
          example: ETH_TEST5
        decimals:
          type: number
          description: The number of decimals of the token
          example: 18
        vaultAccountId:
          type: string
          description: >-
            The id of the vault account that initiated the request to issue the
            token. Will be empty if token was issued outside of Fireblocks.
          example: '0'
      required:
        - assetId
    CollectionMetadataDto:
      type: object
      properties:
        fbCollectionId:
          type: string
          description: Fireblocks collection id
          example: 911fe739f0d4d123c98fd366c3bed35c6e30c00e
        name:
          type: string
          description: Collection name
          example: Rarible
        symbol:
          type: string
          description: Collection symbol
          example: RARI
        standard:
          type: string
          description: Collection contract standard
          example:
            - ERC721
            - ERC1155
            - FA2
        blockchainDescriptor:
          type: string
          description: Collection's blockchain
          example: ETH
        contractAddress:
          type: string
          description: Collection contract address
          example: '0x1723017329a804564bC8d215496C89eaBf1F3211'
      required:
        - fbCollectionId
        - blockchainDescriptor
    ContractMetadataDto:
      type: object
      properties:
        id:
          type: string
          description: The deployed contract ID
          example: fbfbfbfb-fbfb-fbfb-fbfb-fbfbfbfbfbfb
        blockchainId:
          type: string
          description: The blockchain ID
          example: B7QG017M
        contractAddress:
          type: string
          description: The address of the token contract
          example: '0x1234567890abcdef1234567890abcdef12345678'
        contractTemplateId:
          type: string
          description: The contract template ID
          example: b70701f4-d7b1-4795-a8ee-b09cdb5b850d
        vaultAccountId:
          type: string
          description: The vault account ID that initiated the request to issue the token
          example: '0'
      required:
        - id
        - blockchainId
        - contractAddress
        - contractTemplateId
    Parameter:
      type: object
      properties:
        name:
          type: string
          example: _name
          description: The name of the parameter as it appears in the ABI
        description:
          type: string
          example: The name of the token
          description: >-
            A description of the parameter, fetched from the devdoc of this
            contract
        internalType:
          type: string
          example: string
          description: The internal type of the parameter as it appears in the ABI
        type:
          type: string
          example: string
          description: The type of the parameter as it appears in the ABI
        components:
          type: array
          items:
            $ref: '#/components/schemas/Parameter'
      required:
        - name
        - type
    LeanAbiFunction:
      type: object
      properties:
        name:
          type: string
          example: initialize
          description: The function name
        inputs:
          description: The function inputs
          type: array
          items:
            $ref: '#/components/schemas/ParameterWithValue'
        outputs:
          description: The function outputs
          type: array
          items:
            $ref: '#/components/schemas/ParameterWithValue'
        stateMutability:
          type: string
          enum:
            - view
            - pure
            - nonpayable
            - payable
          example: nonpayable
          description: >-
            The state mutability of the function (e.g., view, pure, nonpayable,
            payable)
      required:
        - inputs

````